/*
 * Academic License - for use in teaching, academic research, and meeting
 * course requirements at degree granting institutions only.  Not for
 * government, commercial, or other organizational use.
 *
 * File: ETechnik_Projekt.c
 *
 * Code generated for Simulink model 'ETechnik_Projekt'.
 *
 * Model version                  : 1.57
 * Simulink Coder version         : 9.7 (R2022a) 13-Nov-2021
 * C/C++ source code generated on : Mon Jan  9 18:21:00 2023
 *
 * Target selection: ert.tlc
 * Embedded hardware selection: Atmel->AVR
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */

#include "ETechnik_Projekt.h"
#include "rtwtypes.h"
#include <string.h>
#include "ETechnik_Projekt_types.h"
#include "ETechnik_Projekt_private.h"
#include <math.h>
#include "rt_nonfinite.h"

/* Block signals (default storage) */
B_ETechnik_Projekt_T ETechnik_Projekt_B;

/* Block states (default storage) */
DW_ETechnik_Projekt_T ETechnik_Projekt_DW;

/* Real-time model */
static RT_MODEL_ETechnik_Projekt_T ETechnik_Projekt_M_;
RT_MODEL_ETechnik_Projekt_T *const ETechnik_Projekt_M = &ETechnik_Projekt_M_;
static void rate_monotonic_scheduler(void);

/*
 * Set which subrates need to run this base step (base rate always runs).
 * This function must be called prior to calling the model step function
 * in order to remember which rates need to run this base step.  The
 * buffering of events allows for overlapping preemption.
 */
void ETechnik_Projekt_SetEventsForThisBaseStep(boolean_T *eventFlags)
{
  /* Task runs when its counter is zero, computed via rtmStepTask macro */
  eventFlags[1] = ((boolean_T)rtmStepTask(ETechnik_Projekt_M, 1));
}

/*
 *         This function updates active task flag for each subrate
 *         and rate transition flags for tasks that exchange data.
 *         The function assumes rate-monotonic multitasking scheduler.
 *         The function must be called at model base rate so that
 *         the generated code self-manages all its subrates and rate
 *         transition flags.
 */
static void rate_monotonic_scheduler(void)
{
  /* To ensure a deterministic data transfer between two rates,
   * data is transferred at the priority of a fast task and the frequency
   * of the slow task.  The following flags indicate when the data transfer
   * happens.  That is, a rate interaction flag is set true when both rates
   * will run, and false otherwise.
   */

  /* tid 0 shares data with slower tid rate: 1 */
  ETechnik_Projekt_M->Timing.RateInteraction.TID0_1 =
    (ETechnik_Projekt_M->Timing.TaskCounters.TID[1] == 0);

  /* Compute which subrates run during the next base time step.  Subrates
   * are an integer multiple of the base rate counter.  Therefore, the subtask
   * counter is reset when it reaches its limit (zero means run).
   */
  (ETechnik_Projekt_M->Timing.TaskCounters.TID[1])++;
  if ((ETechnik_Projekt_M->Timing.TaskCounters.TID[1]) > 4) {/* Sample time: [0.5s, 0.0s] */
    ETechnik_Projekt_M->Timing.TaskCounters.TID[1] = 0;
  }
}

real_T rt_roundd_snf(real_T u)
{
  real_T y;
  if (fabs(u) < 4.503599627370496E+15) {
    if (u >= 0.5) {
      y = floor(u + 0.5);
    } else if (u > -0.5) {
      y = u * 0.0;
    } else {
      y = ceil(u - 0.5);
    }
  } else {
    y = u;
  }

  return y;
}

/* Model step function for TID0 */
void ETechnik_Projekt_step0(void)      /* Sample time: [0.1s, 0.0s] */
{
  MW_AnalogIn_ResultDataType_Type datatype_id;
  codertarget_arduinobase_inter_T *obj;
  int16_T i;
  uint16_T b_varargout_1;
  uint16_T b_varargout_1_0;
  char_T tmp[31];
  boolean_T b_value;
  boolean_T b_value_0;
  boolean_T rtb_AND1;
  boolean_T rtb_GreaterThan_n;

  {                                    /* Sample time: [0.1s, 0.0s] */
    rate_monotonic_scheduler();
  }

  /* MATLABSystem: '<S1>/Drucksensor 1' */
  if (ETechnik_Projekt_DW.obj_n.SampleTime !=
      ETechnik_Projekt_P.Drucksensor1_SampleTime) {
    ETechnik_Projekt_DW.obj_n.SampleTime =
      ETechnik_Projekt_P.Drucksensor1_SampleTime;
  }

  obj = &ETechnik_Projekt_DW.obj_n;
  obj->AnalogInDriverObj.MW_ANALOGIN_HANDLE = MW_AnalogIn_GetHandle(54UL);
  datatype_id = MW_ANALOGIN_UINT16;
  MW_AnalogInSingle_ReadResult
    (ETechnik_Projekt_DW.obj_n.AnalogInDriverObj.MW_ANALOGIN_HANDLE,
     &b_varargout_1, datatype_id);

  /* MATLABSystem: '<S1>/Drucksensor 2' */
  if (ETechnik_Projekt_DW.obj_l.SampleTime !=
      ETechnik_Projekt_P.Drucksensor2_SampleTime) {
    ETechnik_Projekt_DW.obj_l.SampleTime =
      ETechnik_Projekt_P.Drucksensor2_SampleTime;
  }

  obj = &ETechnik_Projekt_DW.obj_l;
  obj->AnalogInDriverObj.MW_ANALOGIN_HANDLE = MW_AnalogIn_GetHandle(55UL);
  datatype_id = MW_ANALOGIN_UINT16;
  MW_AnalogInSingle_ReadResult
    (ETechnik_Projekt_DW.obj_l.AnalogInDriverObj.MW_ANALOGIN_HANDLE,
     &b_varargout_1_0, datatype_id);

  /* MATLABSystem: '<S2>/Digital Input' */
  if (ETechnik_Projekt_DW.obj_p.SampleTime !=
      ETechnik_Projekt_P.DigitalInput_SampleTime) {
    ETechnik_Projekt_DW.obj_p.SampleTime =
      ETechnik_Projekt_P.DigitalInput_SampleTime;
  }

  b_value = readDigitalPin(8);

  /* MATLABSystem: '<S3>/Lautstrkesensor ' */
  if (ETechnik_Projekt_DW.obj_f.SampleTime !=
      ETechnik_Projekt_P.Lautstrkesensor_SampleTime) {
    ETechnik_Projekt_DW.obj_f.SampleTime =
      ETechnik_Projekt_P.Lautstrkesensor_SampleTime;
  }

  b_value_0 = readDigitalPin(10);

  /* RateTransition generated from: '<S6>/Data Store Write' incorporates:
   *  RateTransition generated from: '<S6>/Data Store Write1'
   */
  if (ETechnik_Projekt_M->Timing.RateInteraction.TID0_1) {
    /* RateTransition generated from: '<S6>/Data Store Write' */
    ETechnik_Projekt_B.Temperature = ETechnik_Projekt_DW.Temperature_Buffer0;

    /* RateTransition generated from: '<S6>/Data Store Write1' */
    ETechnik_Projekt_B.Feutigkeit = ETechnik_Projekt_DW.Feutigkeit_Buffer0;
  }

  /* End of RateTransition generated from: '<S6>/Data Store Write' */

  /* RelationalOperator: '<S4>/GreaterThan' incorporates:
   *  Constant: '<S4>/Constant'
   *  DataStoreWrite: '<S6>/Data Store Write1'
   */
  rtb_GreaterThan_n = (ETechnik_Projekt_B.Feutigkeit >
                       ETechnik_Projekt_P.Constant_Value_g);

  /* Switch: '<S4>/Switch1' incorporates:
   *  Logic: '<S4>/NOT'
   *  StringConstant: '<S4>/String Constant2'
   *  StringConstant: '<S4>/String Constant7'
   */
  if (!rtb_GreaterThan_n) {
    strncpy(&ETechnik_Projekt_B.Switch1[0],
            &ETechnik_Projekt_P.StringConstant2_String[0], 255U);
    ETechnik_Projekt_B.Switch1[255] = '\x00';
  } else {
    strncpy(&ETechnik_Projekt_B.Switch1[0],
            &ETechnik_Projekt_P.StringConstant7_String[0], 255U);
    ETechnik_Projekt_B.Switch1[255] = '\x00';
  }

  /* End of Switch: '<S4>/Switch1' */

  /* Logic: '<S4>/AND1' incorporates:
   *  Constant: '<S4>/Constant1'
   *  Constant: '<S4>/Constant2'
   *  DataStoreWrite: '<S6>/Data Store Write'
   *  RelationalOperator: '<S4>/GreaterThan1'
   *  RelationalOperator: '<S4>/GreaterThan2'
   */
  rtb_AND1 = ((ETechnik_Projekt_B.Temperature >
               ETechnik_Projekt_P.Constant1_Value_f) &&
              (ETechnik_Projekt_B.Temperature <
               ETechnik_Projekt_P.Constant2_Value));

  /* Switch: '<S4>/Switch' incorporates:
   *  Logic: '<S4>/AND'
   *  StringConstant: '<S4>/String Constant'
   *  StringConstant: '<S4>/String Constant8'
   */
  if (rtb_GreaterThan_n && rtb_AND1) {
    strncpy(&ETechnik_Projekt_B.Switch[0],
            &ETechnik_Projekt_P.StringConstant_String[0], 255U);
    ETechnik_Projekt_B.Switch[255] = '\x00';
  } else {
    strncpy(&ETechnik_Projekt_B.Switch[0],
            &ETechnik_Projekt_P.StringConstant8_String[0], 255U);
    ETechnik_Projekt_B.Switch[255] = '\x00';
  }

  /* End of Switch: '<S4>/Switch' */

  /* Switch: '<S4>/Switch2' incorporates:
   *  Logic: '<S4>/NOT1'
   *  StringConstant: '<S4>/String Constant1'
   *  StringConstant: '<S4>/String Constant9'
   */
  if (!rtb_AND1) {
    strncpy(&ETechnik_Projekt_B.Switch2[0],
            &ETechnik_Projekt_P.StringConstant1_String[0], 255U);
    ETechnik_Projekt_B.Switch2[255] = '\x00';
  } else {
    strncpy(&ETechnik_Projekt_B.Switch2[0],
            &ETechnik_Projekt_P.StringConstant9_String[0], 255U);
    ETechnik_Projekt_B.Switch2[255] = '\x00';
  }

  /* End of Switch: '<S4>/Switch2' */

  /* Switch: '<S4>/Switch3' incorporates:
   *  Constant: '<S1>/Constant'
   *  Constant: '<S1>/Constant1'
   *  Constant: '<S1>/Constant10'
   *  Constant: '<S1>/Constant11'
   *  Constant: '<S1>/Constant12'
   *  Constant: '<S1>/Constant6'
   *  Constant: '<S1>/Constant7'
   *  Constant: '<S1>/Constant8'
   *  Constant: '<S1>/Constant9'
   *  Constant: '<S4>/Constant3'
   *  MATLABSystem: '<S1>/Drucksensor 1'
   *  MATLABSystem: '<S1>/Drucksensor 2'
   *  Product: '<S1>/Divide'
   *  Product: '<S7>/Divide'
   *  Product: '<S8>/Divide'
   *  RelationalOperator: '<S4>/GreaterThan3'
   *  StringConstant: '<S4>/String Constant5'
   *  StringConstant: '<S4>/String Constant6'
   *  Sum: '<S1>/Add'
   *  Sum: '<S7>/Add'
   *  Sum: '<S7>/Block1'
   *  Sum: '<S7>/Block2'
   *  Sum: '<S7>/Block3'
   *  Sum: '<S8>/Add'
   *  Sum: '<S8>/Block1'
   *  Sum: '<S8>/Block2'
   *  Sum: '<S8>/Block3'
   */
  if (((((real_T)b_varargout_1 - ETechnik_Projekt_P.Constant6_Value) *
        (ETechnik_Projekt_P.Constant7_Value - ETechnik_Projekt_P.Constant6_Value)
        / (ETechnik_Projekt_P.Constant_Value_e -
           ETechnik_Projekt_P.Constant8_Value) +
        ETechnik_Projekt_P.Constant8_Value) + (((real_T)b_varargout_1_0 -
         ETechnik_Projekt_P.Constant9_Value) *
        (ETechnik_Projekt_P.Constant10_Value -
         ETechnik_Projekt_P.Constant9_Value) /
        (ETechnik_Projekt_P.Constant1_Value -
         ETechnik_Projekt_P.Constant11_Value) +
        ETechnik_Projekt_P.Constant11_Value)) /
      ETechnik_Projekt_P.Constant12_Value > ETechnik_Projekt_P.Constant3_Value_l)
  {
    strncpy(&ETechnik_Projekt_B.Switch3[0],
            &ETechnik_Projekt_P.StringConstant5_String[0], 255U);
    ETechnik_Projekt_B.Switch3[255] = '\x00';
  } else {
    strncpy(&ETechnik_Projekt_B.Switch3[0],
            &ETechnik_Projekt_P.StringConstant6_String[0], 255U);
    ETechnik_Projekt_B.Switch3[255] = '\x00';
  }

  /* End of Switch: '<S4>/Switch3' */

  /* StringConcatenate: '<S4>/String Concatenate' */
  ETechnik_Projekt_B.rtb_StringConcatenate_m[0] = '\x00';
  strncat(&ETechnik_Projekt_B.rtb_StringConcatenate_m[0],
          &ETechnik_Projekt_B.Switch1[0], 255U);
  i = (int16_T)strlen(&ETechnik_Projekt_B.rtb_StringConcatenate_m[0]);
  strncat(&ETechnik_Projekt_B.rtb_StringConcatenate_m[i],
          &ETechnik_Projekt_B.Switch[0], 255U - i);
  i += (int16_T)strlen(&ETechnik_Projekt_B.rtb_StringConcatenate_m[i]);
  strncat(&ETechnik_Projekt_B.rtb_StringConcatenate_m[i],
          &ETechnik_Projekt_B.Switch2[0], 255U - i);
  i += (int16_T)strlen(&ETechnik_Projekt_B.rtb_StringConcatenate_m[i]);
  strncat(&ETechnik_Projekt_B.rtb_StringConcatenate_m[i],
          &ETechnik_Projekt_B.Switch3[0], 255U - i);

  /* StringToASCII: '<Root>/String to ASCII' incorporates:
   *  StringConcatenate: '<S4>/String Concatenate'
   */
  strncpy(&ETechnik_Projekt_B.cv[0],
          &ETechnik_Projekt_B.rtb_StringConcatenate_m[0], 31U);

  /* Switch: '<S5>/Switch' incorporates:
   *  Constant: '<S5>/Constant1'
   *  MATLABSystem: '<S2>/Digital Input'
   *  RelationalOperator: '<S5>/GreaterThan1'
   *  StringConstant: '<S5>/String Constant1'
   *  StringConstant: '<S5>/String Constant5'
   */
  if ((real_T)b_value > ETechnik_Projekt_P.Constant1_Value_p) {
    strncpy(&ETechnik_Projekt_B.Switch1[0],
            &ETechnik_Projekt_P.StringConstant5_String_b[0], 255U);
    ETechnik_Projekt_B.Switch1[255] = '\x00';
  } else {
    strncpy(&ETechnik_Projekt_B.Switch1[0],
            &ETechnik_Projekt_P.StringConstant1_String_a[0], 255U);
    ETechnik_Projekt_B.Switch1[255] = '\x00';
  }

  /* End of Switch: '<S5>/Switch' */

  /* Switch: '<S5>/Switch1' incorporates:
   *  Constant: '<S3>/Constant3'
   *  Constant: '<S3>/Constant4'
   *  Constant: '<S3>/Constant5'
   *  Constant: '<S5>/Constant'
   *  MATLABSystem: '<S3>/Lautstrkesensor '
   *  Product: '<S9>/Divide'
   *  RelationalOperator: '<S5>/GreaterThan'
   *  StringConstant: '<S5>/String Constant2'
   *  StringConstant: '<S5>/String Constant6'
   *  Sum: '<S9>/Add'
   *  Sum: '<S9>/Block1'
   *  Sum: '<S9>/Block2'
   *  Sum: '<S9>/Block3'
   */
  if (((real_T)b_value_0 - ETechnik_Projekt_P.Constant3_Value) *
      (ETechnik_Projekt_P.Constant4_Value - ETechnik_Projekt_P.Constant3_Value) /
      (ETechnik_Projekt_P.Constant5_Value - ETechnik_Projekt_P.Constant3_Value)
      + ETechnik_Projekt_P.Constant3_Value > ETechnik_Projekt_P.Constant_Value_c)
  {
    strncpy(&ETechnik_Projekt_B.Switch1_f[0],
            &ETechnik_Projekt_P.StringConstant6_String_n[0], 255U);
    ETechnik_Projekt_B.Switch1_f[255] = '\x00';
  } else {
    strncpy(&ETechnik_Projekt_B.Switch1_f[0],
            &ETechnik_Projekt_P.StringConstant2_String_h[0], 255U);
    ETechnik_Projekt_B.Switch1_f[255] = '\x00';
  }

  /* End of Switch: '<S5>/Switch1' */

  /* StringConcatenate: '<S5>/String Concatenate' */
  ETechnik_Projekt_B.rtb_StringConcatenate_c[0] = '\x00';
  strncat(&ETechnik_Projekt_B.rtb_StringConcatenate_c[0],
          &ETechnik_Projekt_B.Switch1[0], 255U);
  i = (int16_T)strlen(&ETechnik_Projekt_B.rtb_StringConcatenate_c[0]);
  strncat(&ETechnik_Projekt_B.rtb_StringConcatenate_c[i],
          &ETechnik_Projekt_B.Switch1_f[0], 255U - i);

  /* StringToASCII: '<Root>/String to ASCII1' incorporates:
   *  StringConcatenate: '<S5>/String Concatenate'
   */
  strncpy(&tmp[0], &ETechnik_Projekt_B.rtb_StringConcatenate_c[0], 31U);

  /* MATLABSystem: '<Root>/LCD Display' incorporates:
   *  StringToASCII: '<Root>/String to ASCII'
   *  StringToASCII: '<Root>/String to ASCII1'
   */
  ETechnik_Projekt_B.b_line1Cstr[31] = '\x00';
  for (i = 0; i < 31; i++) {
    ETechnik_Projekt_B.b_line1Cstr[i] = (int8_T)(uint8_T)ETechnik_Projekt_B.cv[i];
    ETechnik_Projekt_B.b_line2Cstr[i] = (int8_T)(uint8_T)tmp[i];
  }

  ETechnik_Projekt_B.b_line2Cstr[31] = '\x00';
  MW_Print_LCD(&ETechnik_Projekt_B.b_line1Cstr[0],
               &ETechnik_Projekt_B.b_line2Cstr[0]);

  /* End of MATLABSystem: '<Root>/LCD Display' */
}

/* Model step function for TID1 */
void ETechnik_Projekt_step1(void)      /* Sample time: [0.5s, 0.0s] */
{
  real_T tmp;
  real32_T rtb_MATLABSystem_o1;
  real32_T rtb_MATLABSystem_o2;
  uint8_T tmp_0;

  /* MATLABSystem: '<S10>/MATLAB System' */
  if (ETechnik_Projekt_DW.obj.Pin != ETechnik_Projekt_P.DHT_Pin) {
    ETechnik_Projekt_DW.obj.Pin = ETechnik_Projekt_P.DHT_Pin;
  }

  if (ETechnik_Projekt_DW.obj.Sensor != ETechnik_Projekt_P.DHT_Tp) {
    ETechnik_Projekt_DW.obj.Sensor = ETechnik_Projekt_P.DHT_Tp;
  }

  if (ETechnik_Projekt_DW.obj.F != ETechnik_Projekt_P.DHT_F) {
    ETechnik_Projekt_DW.obj.F = ETechnik_Projekt_P.DHT_F;
  }

  if (ETechnik_Projekt_DW.obj.SampleTime != ETechnik_Projekt_P.DHT_Ts) {
    ETechnik_Projekt_DW.obj.SampleTime = ETechnik_Projekt_P.DHT_Ts;
  }

  /*         %% Define output properties */
  /*  Call C-function implementing device output */
  rtb_MATLABSystem_o1 = readHumidity();
  if (ETechnik_Projekt_DW.obj.F != 0.0) {
    /*  if in Fahrenheit */
    rtb_MATLABSystem_o2 = readTempF();
    computeHeatIndexF(rtb_MATLABSystem_o2, rtb_MATLABSystem_o1);
  } else {
    /*  if in Celsius */
    rtb_MATLABSystem_o2 = readTemp();
    computeHeatIndex(rtb_MATLABSystem_o2, rtb_MATLABSystem_o1);
  }

  /* End of MATLABSystem: '<S10>/MATLAB System' */

  /* If: '<S6>/If1' */
  if ((rtb_MATLABSystem_o1 > 50.0F) && ((rtb_MATLABSystem_o2 > 22.0F) &&
       (rtb_MATLABSystem_o2 < 23.3F))) {
    /* Outputs for IfAction SubSystem: '<S6>/If Action Subsystem' incorporates:
     *  ActionPort: '<S11>/Action Port'
     */
    /* MATLABSystem: '<S11>/LED grn' incorporates:
     *  Constant: '<S11>/Constant'
     */
    tmp = rt_roundd_snf(ETechnik_Projekt_P.Constant_Value);
    if (tmp < 256.0) {
      if (tmp >= 0.0) {
        tmp_0 = (uint8_T)tmp;
      } else {
        tmp_0 = 0U;
      }
    } else {
      tmp_0 = MAX_uint8_T;
    }

    writeDigitalPin(6, tmp_0);

    /* End of MATLABSystem: '<S11>/LED grn' */
    /* End of Outputs for SubSystem: '<S6>/If Action Subsystem' */
  }

  /* End of If: '<S6>/If1' */

  /* If: '<S6>/If2' */
  if ((rtb_MATLABSystem_o1 < 50.0F) || ((rtb_MATLABSystem_o2 < 22.0F) ||
       (rtb_MATLABSystem_o2 > 23.3F))) {
    /* Outputs for IfAction SubSystem: '<S6>/If Action Subsystem4' incorporates:
     *  ActionPort: '<S12>/Action Port'
     */
    /* MATLABSystem: '<S12>/LED rot' incorporates:
     *  Constant: '<S12>/Constant'
     */
    tmp = rt_roundd_snf(ETechnik_Projekt_P.Constant_Value_o);
    if (tmp < 256.0) {
      if (tmp >= 0.0) {
        tmp_0 = (uint8_T)tmp;
      } else {
        tmp_0 = 0U;
      }
    } else {
      tmp_0 = MAX_uint8_T;
    }

    writeDigitalPin(13, tmp_0);

    /* End of MATLABSystem: '<S12>/LED rot' */
    /* End of Outputs for SubSystem: '<S6>/If Action Subsystem4' */
  }

  /* End of If: '<S6>/If2' */

  /* RateTransition generated from: '<S6>/Data Store Write1' */
  ETechnik_Projekt_DW.Feutigkeit_Buffer0 = rtb_MATLABSystem_o1;

  /* RateTransition generated from: '<S6>/Data Store Write' */
  ETechnik_Projekt_DW.Temperature_Buffer0 = rtb_MATLABSystem_o2;
}

/* Model initialize function */
void ETechnik_Projekt_initialize(void)
{
  /* Registration code */

  /* initialize non-finites */
  rt_InitInfAndNaN(sizeof(real_T));

  {
    codertarget_arduinobase_inter_T *obj;
    real_T tmp;
    real_T tmp_0;
    int16_T i;
    uint8_T pins8[6];
    uint8_T tmp_1;
    uint8_T tmp_2;
    static const uint8_T tmp_3[6] = { 12U, 11U, 5U, 4U, 3U, 2U };

    /* Start for RateTransition generated from: '<S6>/Data Store Write' */
    ETechnik_Projekt_B.Temperature =
      ETechnik_Projekt_P.Temperature_InitialCondition;

    /* Start for RateTransition generated from: '<S6>/Data Store Write1' */
    ETechnik_Projekt_B.Feutigkeit =
      ETechnik_Projekt_P.Feutigkeit_InitialCondition;

    /* InitializeConditions for RateTransition generated from: '<S6>/Data Store Write' */
    ETechnik_Projekt_DW.Temperature_Buffer0 =
      ETechnik_Projekt_P.Temperature_InitialCondition;

    /* InitializeConditions for RateTransition generated from: '<S6>/Data Store Write1' */
    ETechnik_Projekt_DW.Feutigkeit_Buffer0 =
      ETechnik_Projekt_P.Feutigkeit_InitialCondition;

    /* SystemInitialize for IfAction SubSystem: '<S6>/If Action Subsystem' */
    /* Start for MATLABSystem: '<S11>/LED grn' */
    ETechnik_Projekt_DW.obj_b.matlabCodegenIsDeleted = false;
    ETechnik_Projekt_DW.obj_b.isInitialized = 1L;
    digitalIOSetup(6, 1);
    ETechnik_Projekt_DW.obj_b.isSetupComplete = true;

    /* End of SystemInitialize for SubSystem: '<S6>/If Action Subsystem' */

    /* SystemInitialize for IfAction SubSystem: '<S6>/If Action Subsystem4' */
    /* Start for MATLABSystem: '<S12>/LED rot' */
    ETechnik_Projekt_DW.obj_d.matlabCodegenIsDeleted = false;
    ETechnik_Projekt_DW.obj_d.isInitialized = 1L;
    digitalIOSetup(13, 1);
    ETechnik_Projekt_DW.obj_d.isSetupComplete = true;

    /* End of SystemInitialize for SubSystem: '<S6>/If Action Subsystem4' */

    /* Start for MATLABSystem: '<S1>/Drucksensor 1' */
    ETechnik_Projekt_DW.obj_n.matlabCodegenIsDeleted = true;
    ETechnik_Projekt_DW.obj_n.isInitialized = 0L;
    ETechnik_Projekt_DW.obj_n.SampleTime = -1.0;
    ETechnik_Projekt_DW.obj_n.matlabCodegenIsDeleted = false;
    ETechnik_Projekt_DW.obj_n.SampleTime =
      ETechnik_Projekt_P.Drucksensor1_SampleTime;
    obj = &ETechnik_Projekt_DW.obj_n;
    ETechnik_Projekt_DW.obj_n.isSetupComplete = false;
    ETechnik_Projekt_DW.obj_n.isInitialized = 1L;
    obj->AnalogInDriverObj.MW_ANALOGIN_HANDLE = MW_AnalogInSingle_Open(54UL);
    ETechnik_Projekt_DW.obj_n.isSetupComplete = true;

    /* Start for MATLABSystem: '<S1>/Drucksensor 2' */
    ETechnik_Projekt_DW.obj_l.matlabCodegenIsDeleted = true;
    ETechnik_Projekt_DW.obj_l.isInitialized = 0L;
    ETechnik_Projekt_DW.obj_l.SampleTime = -1.0;
    ETechnik_Projekt_DW.obj_l.matlabCodegenIsDeleted = false;
    ETechnik_Projekt_DW.obj_l.SampleTime =
      ETechnik_Projekt_P.Drucksensor2_SampleTime;
    obj = &ETechnik_Projekt_DW.obj_l;
    ETechnik_Projekt_DW.obj_l.isSetupComplete = false;
    ETechnik_Projekt_DW.obj_l.isInitialized = 1L;
    obj->AnalogInDriverObj.MW_ANALOGIN_HANDLE = MW_AnalogInSingle_Open(55UL);
    ETechnik_Projekt_DW.obj_l.isSetupComplete = true;

    /* Start for MATLABSystem: '<S2>/Digital Input' */
    ETechnik_Projekt_DW.obj_p.matlabCodegenIsDeleted = false;
    ETechnik_Projekt_DW.obj_p.SampleTime =
      ETechnik_Projekt_P.DigitalInput_SampleTime;
    ETechnik_Projekt_DW.obj_p.isInitialized = 1L;
    digitalIOSetup(8, 0);
    ETechnik_Projekt_DW.obj_p.isSetupComplete = true;

    /* Start for MATLABSystem: '<S3>/Lautstrkesensor ' */
    ETechnik_Projekt_DW.obj_f.matlabCodegenIsDeleted = false;
    ETechnik_Projekt_DW.obj_f.SampleTime =
      ETechnik_Projekt_P.Lautstrkesensor_SampleTime;
    ETechnik_Projekt_DW.obj_f.isInitialized = 1L;
    digitalIOSetup(10, 0);
    ETechnik_Projekt_DW.obj_f.isSetupComplete = true;

    /* Start for MATLABSystem: '<Root>/LCD Display' */
    /*  Constructor */
    for (i = 0; i < 6; i++) {
      pins8[i] = tmp_3[i];
    }

    MW_LCD_Init(pins8[0], pins8[1], pins8[2], pins8[3], pins8[4], pins8[5]);

    /* End of Start for MATLABSystem: '<Root>/LCD Display' */

    /* Start for MATLABSystem: '<S10>/MATLAB System' */
    /*  Constructor */
    /*  Support name-value pair arguments when constructing the object. */
    ETechnik_Projekt_DW.obj.matlabCodegenIsDeleted = false;
    ETechnik_Projekt_DW.obj.Pin = ETechnik_Projekt_P.DHT_Pin;
    ETechnik_Projekt_DW.obj.Sensor = ETechnik_Projekt_P.DHT_Tp;
    ETechnik_Projekt_DW.obj.F = ETechnik_Projekt_P.DHT_F;
    ETechnik_Projekt_DW.obj.SampleTime = ETechnik_Projekt_P.DHT_Ts;
    ETechnik_Projekt_DW.obj.isInitialized = 1L;

    /*         %% Define output properties */
    /*  Call C-function implementing device initialization */
    tmp = rt_roundd_snf(ETechnik_Projekt_DW.obj.Pin);
    tmp_0 = rt_roundd_snf(ETechnik_Projekt_DW.obj.Sensor);
    if (tmp < 256.0) {
      if (tmp >= 0.0) {
        tmp_1 = (uint8_T)tmp;
      } else {
        tmp_1 = 0U;
      }
    } else {
      tmp_1 = MAX_uint8_T;
    }

    if (tmp_0 < 256.0) {
      if (tmp_0 >= 0.0) {
        tmp_2 = (uint8_T)tmp_0;
      } else {
        tmp_2 = 0U;
      }
    } else {
      tmp_2 = MAX_uint8_T;
    }

    setDHT(tmp_1, tmp_2);
    ETechnik_Projekt_DW.obj.isSetupComplete = true;

    /* End of Start for MATLABSystem: '<S10>/MATLAB System' */
  }
}

/* Model terminate function */
void ETechnik_Projekt_terminate(void)
{
  codertarget_arduinobase_inter_T *obj;

  /* Terminate for MATLABSystem: '<S1>/Drucksensor 1' */
  obj = &ETechnik_Projekt_DW.obj_n;
  if (!ETechnik_Projekt_DW.obj_n.matlabCodegenIsDeleted) {
    ETechnik_Projekt_DW.obj_n.matlabCodegenIsDeleted = true;
    if ((ETechnik_Projekt_DW.obj_n.isInitialized == 1L) &&
        ETechnik_Projekt_DW.obj_n.isSetupComplete) {
      obj->AnalogInDriverObj.MW_ANALOGIN_HANDLE = MW_AnalogIn_GetHandle(54UL);
      MW_AnalogIn_Close
        (ETechnik_Projekt_DW.obj_n.AnalogInDriverObj.MW_ANALOGIN_HANDLE);
    }
  }

  /* End of Terminate for MATLABSystem: '<S1>/Drucksensor 1' */

  /* Terminate for MATLABSystem: '<S1>/Drucksensor 2' */
  obj = &ETechnik_Projekt_DW.obj_l;
  if (!ETechnik_Projekt_DW.obj_l.matlabCodegenIsDeleted) {
    ETechnik_Projekt_DW.obj_l.matlabCodegenIsDeleted = true;
    if ((ETechnik_Projekt_DW.obj_l.isInitialized == 1L) &&
        ETechnik_Projekt_DW.obj_l.isSetupComplete) {
      obj->AnalogInDriverObj.MW_ANALOGIN_HANDLE = MW_AnalogIn_GetHandle(55UL);
      MW_AnalogIn_Close
        (ETechnik_Projekt_DW.obj_l.AnalogInDriverObj.MW_ANALOGIN_HANDLE);
    }
  }

  /* End of Terminate for MATLABSystem: '<S1>/Drucksensor 2' */

  /* Terminate for MATLABSystem: '<S2>/Digital Input' */
  if (!ETechnik_Projekt_DW.obj_p.matlabCodegenIsDeleted) {
    ETechnik_Projekt_DW.obj_p.matlabCodegenIsDeleted = true;
  }

  /* End of Terminate for MATLABSystem: '<S2>/Digital Input' */

  /* Terminate for MATLABSystem: '<S3>/Lautstrkesensor ' */
  if (!ETechnik_Projekt_DW.obj_f.matlabCodegenIsDeleted) {
    ETechnik_Projekt_DW.obj_f.matlabCodegenIsDeleted = true;
  }

  /* End of Terminate for MATLABSystem: '<S3>/Lautstrkesensor ' */

  /* Terminate for MATLABSystem: '<S10>/MATLAB System' */
  if (!ETechnik_Projekt_DW.obj.matlabCodegenIsDeleted) {
    ETechnik_Projekt_DW.obj.matlabCodegenIsDeleted = true;
  }

  /* End of Terminate for MATLABSystem: '<S10>/MATLAB System' */

  /* Terminate for IfAction SubSystem: '<S6>/If Action Subsystem' */
  /* Terminate for MATLABSystem: '<S11>/LED grn' */
  if (!ETechnik_Projekt_DW.obj_b.matlabCodegenIsDeleted) {
    ETechnik_Projekt_DW.obj_b.matlabCodegenIsDeleted = true;
  }

  /* End of Terminate for MATLABSystem: '<S11>/LED grn' */
  /* End of Terminate for SubSystem: '<S6>/If Action Subsystem' */

  /* Terminate for IfAction SubSystem: '<S6>/If Action Subsystem4' */
  /* Terminate for MATLABSystem: '<S12>/LED rot' */
  if (!ETechnik_Projekt_DW.obj_d.matlabCodegenIsDeleted) {
    ETechnik_Projekt_DW.obj_d.matlabCodegenIsDeleted = true;
  }

  /* End of Terminate for MATLABSystem: '<S12>/LED rot' */
  /* End of Terminate for SubSystem: '<S6>/If Action Subsystem4' */
}

/*
 * File trailer for generated code.
 *
 * [EOF]
 */
