/*
 * Academic License - for use in teaching, academic research, and meeting
 * course requirements at degree granting institutions only.  Not for
 * government, commercial, or other organizational use.
 *
 * File: ETechnik_Projekt.h
 *
 * Code generated for Simulink model 'ETechnik_Projekt'.
 *
 * Model version                  : 1.57
 * Simulink Coder version         : 9.7 (R2022a) 13-Nov-2021
 * C/C++ source code generated on : Mon Jan  9 18:21:00 2023
 *
 * Target selection: ert.tlc
 * Embedded hardware selection: Atmel->AVR
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */

#ifndef RTW_HEADER_ETechnik_Projekt_h_
#define RTW_HEADER_ETechnik_Projekt_h_
#ifndef ETechnik_Projekt_COMMON_INCLUDES_
#define ETechnik_Projekt_COMMON_INCLUDES_
#include "rtwtypes.h"
#include "rtw_continuous.h"
#include "rtw_solver.h"
#include "MW_AnalogIn.h"
#include "MW_arduino_digitalio.h"
#include "LCD_wrapper.h"
#include "dht_arduino.h"
#endif                                 /* ETechnik_Projekt_COMMON_INCLUDES_ */

#include "ETechnik_Projekt_types.h"
#include "rtGetInf.h"
#include "rt_nonfinite.h"
#include <stddef.h>
#include "MW_target_hardware_resources.h"

/* Macros for accessing real-time model data structure */
#ifndef rtmGetErrorStatus
#define rtmGetErrorStatus(rtm)         ((rtm)->errorStatus)
#endif

#ifndef rtmSetErrorStatus
#define rtmSetErrorStatus(rtm, val)    ((rtm)->errorStatus = (val))
#endif

#ifndef rtmStepTask
#define rtmStepTask(rtm, idx)          ((rtm)->Timing.TaskCounters.TID[(idx)] == 0)
#endif

#ifndef rtmTaskCounter
#define rtmTaskCounter(rtm, idx)       ((rtm)->Timing.TaskCounters.TID[(idx)])
#endif

/* Block signals (default storage) */
typedef struct {
  char_T rtb_StringConcatenate_m[256];
  char_T rtb_StringConcatenate_c[256];
  char_T Switch1[256];                 /* '<S4>/Switch1' */
  char_T Switch[256];                  /* '<S4>/Switch' */
  char_T Switch2[256];                 /* '<S4>/Switch2' */
  char_T Switch3[256];                 /* '<S4>/Switch3' */
  char_T Switch1_f[256];               /* '<S5>/Switch1' */
  char_T b_line1Cstr[32];
  char_T b_line2Cstr[32];
  char_T cv[31];
  real32_T Temperature;                /* '<S6>/DHT' */
  real32_T Feutigkeit;                 /* '<S6>/DHT' */
} B_ETechnik_Projekt_T;

/* Block states (default storage) for system '<Root>' */
typedef struct {
  read_dht_ETechnik_Projekt_T obj;     /* '<S10>/MATLAB System' */
  codertarget_arduinobase_inter_T obj_l;/* '<S1>/Drucksensor 2' */
  codertarget_arduinobase_inter_T obj_n;/* '<S1>/Drucksensor 1' */
  codertarget_arduinobase_block_T obj_f;/* '<S3>/Lautstrkesensor ' */
  codertarget_arduinobase_block_T obj_p;/* '<S2>/Digital Input' */
  codertarget_arduinobase_blo_o_T obj_d;/* '<S12>/LED rot' */
  codertarget_arduinobase_blo_o_T obj_b;/* '<S11>/LED grn' */
  real32_T Temperature_Buffer0;        /* synthesized block */
  real32_T Feutigkeit_Buffer0;         /* synthesized block */
} DW_ETechnik_Projekt_T;

/* Parameters (default storage) */
struct P_ETechnik_Projekt_T_ {
  real_T DHT_F;                        /* Mask Parameter: DHT_F
                                        * Referenced by: '<S10>/MATLAB System'
                                        */
  real_T DHT_Pin;                      /* Mask Parameter: DHT_Pin
                                        * Referenced by: '<S10>/MATLAB System'
                                        */
  real_T DHT_Tp;                       /* Mask Parameter: DHT_Tp
                                        * Referenced by: '<S10>/MATLAB System'
                                        */
  real_T DHT_Ts;                       /* Mask Parameter: DHT_Ts
                                        * Referenced by: '<S10>/MATLAB System'
                                        */
  real_T Drucksensor1_SampleTime;      /* Expression: -1
                                        * Referenced by: '<S1>/Drucksensor 1'
                                        */
  real_T Drucksensor2_SampleTime;      /* Expression: -1
                                        * Referenced by: '<S1>/Drucksensor 2'
                                        */
  real_T DigitalInput_SampleTime;      /* Expression: 0.1
                                        * Referenced by: '<S2>/Digital Input'
                                        */
  real_T Lautstrkesensor_SampleTime;   /* Expression: 0.1
                                        * Referenced by: '<S3>/Lautstrkesensor '
                                        */
  real_T Constant_Value;               /* Expression: 1
                                        * Referenced by: '<S11>/Constant'
                                        */
  real_T Constant_Value_o;             /* Expression: 1
                                        * Referenced by: '<S12>/Constant'
                                        */
  real_T Constant6_Value;              /* Expression: 0
                                        * Referenced by: '<S1>/Constant6'
                                        */
  real_T Constant7_Value;              /* Expression: 1023
                                        * Referenced by: '<S1>/Constant7'
                                        */
  real_T Constant_Value_e;             /* Expression: 2000
                                        * Referenced by: '<S1>/Constant'
                                        */
  real_T Constant8_Value;              /* Expression: 20
                                        * Referenced by: '<S1>/Constant8'
                                        */
  real_T Constant9_Value;              /* Expression: 0
                                        * Referenced by: '<S1>/Constant9'
                                        */
  real_T Constant10_Value;             /* Expression: 1023
                                        * Referenced by: '<S1>/Constant10'
                                        */
  real_T Constant1_Value;              /* Expression: 2000
                                        * Referenced by: '<S1>/Constant1'
                                        */
  real_T Constant11_Value;             /* Expression: 20
                                        * Referenced by: '<S1>/Constant11'
                                        */
  real_T Constant12_Value;             /* Expression: 2
                                        * Referenced by: '<S1>/Constant12'
                                        */
  real_T Constant3_Value;              /* Expression: 0
                                        * Referenced by: '<S3>/Constant3'
                                        */
  real_T Constant4_Value;              /* Expression: 1023
                                        * Referenced by: '<S3>/Constant4'
                                        */
  real_T Constant5_Value;              /* Expression: 100
                                        * Referenced by: '<S3>/Constant5'
                                        */
  real_T Constant_Value_g;             /* Expression: 50
                                        * Referenced by: '<S4>/Constant'
                                        */
  real_T Constant1_Value_f;            /* Expression: 22
                                        * Referenced by: '<S4>/Constant1'
                                        */
  real_T Constant2_Value;              /* Expression: 23.3
                                        * Referenced by: '<S4>/Constant2'
                                        */
  real_T Constant3_Value_l;            /* Expression: 200
                                        * Referenced by: '<S4>/Constant3'
                                        */
  real_T Constant1_Value_p;            /* Expression: 450
                                        * Referenced by: '<S5>/Constant1'
                                        */
  real_T Constant_Value_c;             /* Expression: 40
                                        * Referenced by: '<S5>/Constant'
                                        */
  real_T DataStoreMemory2_InitialValue;/* Expression: 0
                                        * Referenced by: '<Root>/Data Store Memory2'
                                        */
  real_T DataStoreMemory3_InitialValue;/* Expression: 0
                                        * Referenced by: '<Root>/Data Store Memory3'
                                        */
  char_T StringConstant2_String[256];
                                   /* Computed Parameter: StringConstant2_String
                                    * Referenced by: '<S4>/String Constant2'
                                    */
  char_T StringConstant7_String[256];
                                   /* Computed Parameter: StringConstant7_String
                                    * Referenced by: '<S4>/String Constant7'
                                    */
  char_T StringConstant_String[256];/* Computed Parameter: StringConstant_String
                                     * Referenced by: '<S4>/String Constant'
                                     */
  char_T StringConstant8_String[256];
                                   /* Computed Parameter: StringConstant8_String
                                    * Referenced by: '<S4>/String Constant8'
                                    */
  char_T StringConstant1_String[256];
                                   /* Computed Parameter: StringConstant1_String
                                    * Referenced by: '<S4>/String Constant1'
                                    */
  char_T StringConstant9_String[256];
                                   /* Computed Parameter: StringConstant9_String
                                    * Referenced by: '<S4>/String Constant9'
                                    */
  char_T StringConstant5_String[256];
                                   /* Computed Parameter: StringConstant5_String
                                    * Referenced by: '<S4>/String Constant5'
                                    */
  char_T StringConstant6_String[256];
                                   /* Computed Parameter: StringConstant6_String
                                    * Referenced by: '<S4>/String Constant6'
                                    */
  char_T StringConstant5_String_b[256];
                                 /* Computed Parameter: StringConstant5_String_b
                                  * Referenced by: '<S5>/String Constant5'
                                  */
  char_T StringConstant1_String_a[256];
                                 /* Computed Parameter: StringConstant1_String_a
                                  * Referenced by: '<S5>/String Constant1'
                                  */
  char_T StringConstant6_String_n[256];
                                 /* Computed Parameter: StringConstant6_String_n
                                  * Referenced by: '<S5>/String Constant6'
                                  */
  char_T StringConstant2_String_h[256];
                                 /* Computed Parameter: StringConstant2_String_h
                                  * Referenced by: '<S5>/String Constant2'
                                  */
  real32_T Temperature_InitialCondition;
                             /* Computed Parameter: Temperature_InitialCondition
                              * Referenced by:
                              */
  real32_T Feutigkeit_InitialCondition;
                              /* Computed Parameter: Feutigkeit_InitialCondition
                               * Referenced by:
                               */
  real32_T DataStoreMemory_InitialValue;
                             /* Computed Parameter: DataStoreMemory_InitialValue
                              * Referenced by: '<Root>/Data Store Memory'
                              */
  real32_T DataStoreMemory1_InitialValue;
                            /* Computed Parameter: DataStoreMemory1_InitialValue
                             * Referenced by: '<Root>/Data Store Memory1'
                             */
  boolean_T Gas_InitialValue;          /* Computed Parameter: Gas_InitialValue
                                        * Referenced by: '<Root>/Gas'
                                        */
};

/* Real-time Model Data Structure */
struct tag_RTM_ETechnik_Projekt_T {
  const char_T * volatile errorStatus;

  /*
   * Timing:
   * The following substructure contains information regarding
   * the timing information for the model.
   */
  struct {
    struct {
      uint8_T TID[2];
    } TaskCounters;

    struct {
      boolean_T TID0_1;
    } RateInteraction;
  } Timing;
};

/* Block parameters (default storage) */
extern P_ETechnik_Projekt_T ETechnik_Projekt_P;

/* Block signals (default storage) */
extern B_ETechnik_Projekt_T ETechnik_Projekt_B;

/* Block states (default storage) */
extern DW_ETechnik_Projekt_T ETechnik_Projekt_DW;

/* External function called from main */
extern void ETechnik_Projekt_SetEventsForThisBaseStep(boolean_T *eventFlags);

/* Model entry point functions */
extern void ETechnik_Projekt_SetEventsForThisBaseStep(boolean_T *eventFlags);
extern void ETechnik_Projekt_initialize(void);
extern void ETechnik_Projekt_step0(void);
extern void ETechnik_Projekt_step1(void);
extern void ETechnik_Projekt_terminate(void);

/* Real-time Model object */
extern RT_MODEL_ETechnik_Projekt_T *const ETechnik_Projekt_M;
extern volatile boolean_T stopRequested;
extern volatile boolean_T runModel;

/*-
 * The generated code includes comments that allow you to trace directly
 * back to the appropriate location in the model.  The basic format
 * is <system>/block_name, where system is the system number (uniquely
 * assigned by Simulink) and block_name is the name of the block.
 *
 * Use the MATLAB hilite_system command to trace the generated code back
 * to the model.  For example,
 *
 * hilite_system('<S3>')    - opens system 3
 * hilite_system('<S3>/Kp') - opens and selects block Kp which resides in S3
 *
 * Here is the system hierarchy for this model
 *
 * '<Root>' : 'ETechnik_Projekt'
 * '<S1>'   : 'ETechnik_Projekt/Drucksensoren'
 * '<S2>'   : 'ETechnik_Projekt/Gassensor'
 * '<S3>'   : 'ETechnik_Projekt/Lautstrke'
 * '<S4>'   : 'ETechnik_Projekt/Line 1'
 * '<S5>'   : 'ETechnik_Projekt/Line 2'
 * '<S6>'   : 'ETechnik_Projekt/Temperature//Humidity'
 * '<S7>'   : 'ETechnik_Projekt/Drucksensoren/map2'
 * '<S8>'   : 'ETechnik_Projekt/Drucksensoren/map3'
 * '<S9>'   : 'ETechnik_Projekt/Lautstrke/map1'
 * '<S10>'  : 'ETechnik_Projekt/Temperature//Humidity/DHT'
 * '<S11>'  : 'ETechnik_Projekt/Temperature//Humidity/If Action Subsystem'
 * '<S12>'  : 'ETechnik_Projekt/Temperature//Humidity/If Action Subsystem4'
 */
#endif                                 /* RTW_HEADER_ETechnik_Projekt_h_ */

/*
 * File trailer for generated code.
 *
 * [EOF]
 */
